/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_STRING_INL
#define __TOOLBOX_STRING_INL


// --- Class String ---

inline String::String(unsigned int number)
{
	ASSERTION_THIS;
	String((long) number);
}

inline String String::operator +(const class String & String) const
{
	ASSERTION_THIS;
	return *this + String.Data;
}

inline String String::operator +(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return *this + String->Data;
}

inline String String::operator +(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	String Result(Data);
	Result += string;
	return Result;
}

inline String String::operator +(char character) const
{
	ASSERTION_THIS;

	String Result(Data);
	Result += character;
	return Result;
}

inline String String::operator +(int number) const
{
	ASSERTION_THIS;

	String Result(Data);
	Result += number;
	return Result;
}

inline String String::operator +(unsigned int number) const
{
	ASSERTION_THIS;

	String Result(Data);
	Result += number;
	return Result;
}

inline String String::operator +(long number) const
{
	ASSERTION_THIS;

	String Result(Data);
	Result += number;
	return Result;
}

inline String String::operator +(unsigned long number) const
{
	ASSERTION_THIS;

	String Result(Data);
	Result += number;
	return Result;
}

inline String String::operator +(bool boolean) const
{
	ASSERTION_THIS;

	String Result(Data);
	Result += boolean;
	return Result;
}

inline void String::operator +=(const class String & String)
{
	ASSERTION_THIS;
	Append(String.Data);
}

inline void String::operator +=(const class String * String)
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	Append(String->Data);
}

inline void String::operator +=(const char * string)
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	Append(string);
}

inline void String::operator +=(char character)
{
	ASSERTION_THIS;
	Append(character);
}

inline void String::operator +=(int number)
{
	ASSERTION_THIS;
	Append(number);
}

inline void String::operator +=(unsigned int number)
{
	ASSERTION_THIS;
	Append((long) number);
}

inline void String::operator +=(long number)
{
	ASSERTION_THIS;
	Append(number);
}

inline void String::operator +=(unsigned long number)
{
	ASSERTION_THIS;
	Append(number);
}

inline void String::operator +=(bool boolean)
{
	ASSERTION_THIS;
	Append(boolean);
}

inline void String::operator =(const class String & String)
{
	ASSERTION_THIS;
	*this = String.Data;
}

inline void String::operator =(const class String * String)
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	*this = String->Data;
}

inline void String::operator =(unsigned int number)
{
	ASSERTION_THIS;
	*this = ((long) number);
}

inline bool String::operator <(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) < 0;
}

inline bool String::operator <(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) < 0;
}

inline bool String::operator <(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) < 0;
}

inline bool String::operator <=(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) <= 0;
}

inline bool String::operator <=(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) <= 0;
}

inline bool String::operator <=(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) <= 0;
}

inline bool String::operator >(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) > 0;
}

inline bool String::operator >(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) > 0;
}

inline bool String::operator >(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) > 0;
}

inline bool String::operator >=(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) >= 0;
}

inline bool String::operator >=(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) >= 0;
}

inline bool String::operator >=(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) >= 0;
}

inline bool String::operator ==(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) == 0;
}

inline bool String::operator ==(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) == 0;
}

inline bool String::operator ==(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) == 0;
}

inline bool String::operator !=(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) != 0;
}

inline bool String::operator !=(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) != 0;
}

inline bool String::operator !=(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) != 0;
}

inline char String::operator [](int index) const
{
	ASSERTION_THIS;

	if (index < 0 || index >= (int) strlen(Data))
		return 0;

   return Data[index];
}

inline String::operator const char *() const
{
	ASSERTION_THIS;
	return Data;
}

inline void String::Append(const class String & String)
{
	ASSERTION_THIS;
	Append(String.Data);
}

inline void String::Append(const class String * String)
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	Append(String->Data);
}

inline void String::Append(unsigned int number)
{
	ASSERTION_THIS;
	Append((long) number);
}

inline void String::Clear()
{
	ASSERTION_THIS;
	Data[0] = 0;
}

inline String String::Clone() const
{
	ASSERTION_THIS;
	return String(*this);
}

inline int String::Compare(const String & String1, const String & String2)
{
	return Compare(String1.Data, String2.Data);
}

inline int String::Compare(const String * String1, const String * String2)
{
	ASSERTION(String1 != NULL);
	ASSERTION(String2 != NULL);

	return Compare(String1->Data, String2->Data);
}

inline int String::CompareIC(const String & String1, const String & String2)
{
	return CompareIC(String1.Data, String2.Data);
}

inline int String::CompareIC(const String * String1, const String * String2)
{
	ASSERTION(String1 != NULL);
	ASSERTION(String2 != NULL);

	return CompareIC(String1->Data, String2->Data);
}

inline int String::CompareTo(const String & String) const
{
	return Compare(Data, String.Data);
}

inline int String::CompareTo(const String * String) const
{
	ASSERTION(String != NULL);
	return Compare(Data, String->Data);
}

inline int String::CompareTo(const char * string) const
{
	ASSERTION(string != NULL);
	return Compare(Data, string);
}

inline int String::CompareToIC(const String & String) const
{
	return CompareIC(Data, String.Data);
}

inline int String::CompareToIC(const String * String) const
{
	ASSERTION(String != NULL);
	return CompareIC(Data, String->Data);
}

inline int String::CompareToIC(const char * string) const
{
	ASSERTION(string != NULL);
	return CompareIC(Data, string);
}

inline bool String::Contains(const class String & String) const
{
	ASSERTION_THIS;
	return strstr(Data, String.Data) != NULL;
}

inline bool String::Contains(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return strstr(Data, String->Data) != NULL;
}

inline bool String::Contains(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return strstr(Data, string) != NULL;
}

inline bool String::EndsWith(const class String & String) const
{
	ASSERTION_THIS;
	return EndsWith(String.Data);
}

inline bool String::EndsWith(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return EndsWith(String->Data);
}

inline bool String::EndsWithIC(const class String & String) const
{
	ASSERTION_THIS;
	return EndsWithIC(String.Data);
}

inline bool String::EndsWithIC(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return EndsWithIC(String->Data);
}

inline bool String::Equals(const class String & String) const
{
	ASSERTION_THIS;
	return Compare(Data, String.Data) == 0;
}

inline bool String::Equals(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Compare(Data, String->Data) == 0;
}

inline bool String::Equals(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return Compare(Data, string) == 0;
}

inline bool String::EqualsIC(const class String & String) const
{
	ASSERTION_THIS;
	return CompareIC(Data, String.Data) == 0;
}

inline bool String::EqualsIC(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return CompareIC(Data, String->Data) == 0;
}

inline bool String::EqualsIC(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return CompareIC(Data, string) == 0;
}

inline int String::Find(const class String & String) const
{
	ASSERTION_THIS;
	return Find(String.Data);
}

inline int String::Find(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Find(String->Data);
}

inline int String::Find(const class String & String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	return Find(String.Data, fromIndex);
}

inline int String::Find(const class String * String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return Find(String->Data, fromIndex);
}

inline int String::FindIC(const class String & String) const
{
	ASSERTION_THIS;
	return FindIC(String.Data);
}

inline int String::FindIC(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return FindIC(String->Data);
}

inline int String::FindIC(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return FindIC(string, strlen(Data));
}

inline int String::FindIC(const class String & String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	return FindIC(String.Data, fromIndex);
}

inline int String::FindIC(const class String * String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return FindIC(String->Data, fromIndex);
}

inline int String::FindLast(const class String & String) const
{
	ASSERTION_THIS;
	return FindLast(String.Data);
}

inline int String::FindLast(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return FindLast(String->Data);
}

inline int String::FindLast(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return FindLast(string, strlen(Data));
}

inline int String::FindLast(const class String & String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	return FindLast(String.Data, fromIndex);
}

inline int String::FindLast(const class String * String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return FindLast(String->Data, fromIndex);
}

inline int String::FindLastIC(const class String & String) const
{
	ASSERTION_THIS;
	return FindLastIC(String.Data);
}

inline int String::FindLastIC(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return FindLastIC(String->Data);
}

inline int String::FindLastIC(const char * string) const
{
	ASSERTION_THIS;
	ASSERTION(string != NULL);

	return FindLastIC(string, strlen(Data));
}

inline int String::FindLastIC(const class String & String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	return FindLastIC(String.Data, fromIndex);
}

inline int String::FindLastIC(const class String * String, unsigned int fromIndex) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return FindLastIC(String->Data, fromIndex);
}

inline unsigned int String::GetLength() const
{
	ASSERTION_THIS;
	return strlen(Data);
}

inline void String::Insert(const class String & String, unsigned int index)
{
	ASSERTION_THIS;
	Insert(String.Data, index);
}

inline void String::Insert(const class String * String, unsigned int index)
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	Insert(String->Data, index);
}

inline void String::Insert(unsigned int number, unsigned int index)
{
	ASSERTION_THIS;
	Insert((long) number, index);
}

inline bool String::IsEmpty() const
{
	ASSERTION_THIS;
	return Data[0] == 0;
}

inline void String::Prepend(const class String & String)
{
	ASSERTION_THIS;
	Prepend(String.Data);
}

inline void String::Prepend(const class String * String)
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	Prepend(String->Data);
}

inline void String::Prepend(unsigned int number)
{
	ASSERTION_THIS;
	Prepend((long) number);
}

inline void String::Replace(const String & Text, const String & Replacement)
{
	ASSERTION_THIS;
	Replace(Text.Data, Replacement.Data);
}

inline void String::Replace(const String * Text, const String * Replacement)
{
	ASSERTION_THIS;
	ASSERTION(Text != NULL);
	ASSERTION(Replacement != NULL);

	Replace(Text->Data, Replacement->Data);
}

inline bool String::StartsWith(const class String & String) const
{
	ASSERTION_THIS;
	return StartsWith(String.Data);
}

inline bool String::StartsWith(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return StartsWith(String->Data);
}

inline bool String::StartsWithIC(const class String & String) const
{
	ASSERTION_THIS;
	return StartsWithIC(String.Data);
}

inline bool String::StartsWithIC(const class String * String) const
{
	ASSERTION_THIS;
	ASSERTION(String != NULL);

	return StartsWithIC(String->Data);
}

inline bool String::WriteTo(FILE * file)
{
	ASSERTION_THIS;
	ASSERTION(file != NULL);

	fputs(Data, file);
}


#endif
