/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


// ToolBox
#include <ToolBox\Headers.h>

// Tester
#include "Main.h"

#include <conio.h>


int main(int argc, char **argv)
{
	int testedClasses = 0;
	int performedTests = 0;
	int failedTests = 0;

	printf("Testing ArrayList...\n");
	try
	{
		ArrayList<TestObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ArrayList!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ChecksumCalculator...\n");
	try
	{
		ChecksumCalculator::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ChecksumCalculator!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Config...\n");
	try
	{
		Config::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Config!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ConfigSection...\n");
	try
	{
		ConfigSection::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ConfigSection!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ConfigParameter...\n");
	try
	{
		ConfigParameter::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ConfigParameter!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ContainingList...\n");
	try
	{
		ContainingList<TestListObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ContainingList!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ContainingListItem...\n");
	try
	{
		ContainingListItem<TestListObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ContainingListItem!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ContainingStack...\n");
	try
	{
		ContainingStack<TestStackObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ContainingStack!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ContainingStackItem...\n");
	try
	{
		ContainingStackItem<TestStackObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ContainingStackItem!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing DirectoryEntry...\n");
	try
	{
		DirectoryEntry::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing DirectoryEntry!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Directory...\n");
	try
	{
		Directory::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Directory!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Edge...\n");
	try
	{
		Edge::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Edge!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing EdgeArray...\n");
	try
	{
		EdgeArray::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing EdgeArray!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Graph...\n");
	try
	{
		Graph::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Graph!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing HashMap... (takes some time)\n");
	try
	{
		HashMap<TestObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing HashMap!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing IntKeyHashMap...\n");
	try
	{
		IntKeyHashMap<TestObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing IntKeyHashMap!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Logger...\n");
	try
	{
		Logger::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Logger!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing ParameterLine...\n");
	try
	{
		ParameterLine::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing ParameterLine!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing PathElement...\n");
	try
	{
		PathElement::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing PathElement!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Path...\n");
	try
	{
		Path::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Path!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing PointeredList...\n");
	try
	{
		PointeredList::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing PointeredList!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing PointeredListItem...\n");
	try
	{
		PointeredListItem::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing PointeredListItem!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing PointeredStack...\n");
	try
	{
		PointeredStack::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing PointeredStack!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing PointeredStackItem...\n");
	try
	{
		PointeredStackItem::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing PointeredStackItem!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing SimulationEvent...\n");
	try
	{
		SimulationEvent::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing SimulationEvent!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing SimulationObject...\n");
	try
	{
		SimulationObject::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing SimulationObject!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Simulation...\n");
	try
	{
		Simulation::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Simulation!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing String...\n");
	try
	{
		String::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing String!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing StringKeyHashMap...\n");
	try
	{
		StringKeyHashMap<TestObject>::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing StringKeyHashMap!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing Vertex...\n");
	try
	{
		Vertex::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing Vertex!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("Testing VertexArray...\n");
	try
	{
		VertexArray::RunTestSuite(&performedTests, &failedTests);
	}
	catch (class Exception * Exception)
	{
		printf("%s:%s while testing VertexArray!\n",
			Exception->GetClassName(), Exception->GetMessage());
		failedTests++;
		delete Exception;
	}
	testedClasses++;

	printf("\n%d tests on %d classes done.\n", performedTests, testedClasses);

	if (failedTests > 0)
		printf("There were %d error(s)!!!\n", failedTests);
	else
		printf("All tests successful.\n");

	printf("(press any key)");
	_getch();

	return failedTests > 0;
}
